from typing import Optional

from sqlmodel import Field

from nexium_api import BaseRequestData, BaseResponseData, NexiumAPI, route, BaseRouter, BaseRequestAuth


class RequestAuth(BaseRequestAuth):
    token: Optional[str]


async def check_auth(token):
    print(token)


class Router(BaseRouter):
    request_auth = RequestAuth
    check_request_auth = staticmethod(check_auth)


class RequestData(BaseRequestData):
    ping: bool = Field(default=True)


class ResponseData(BaseResponseData):
    pong: bool = Field(default=True)


async def func(ping: bool):
    return ResponseData()


async def func2(ping: bool):
    return ResponseData()



class Router2(Router):
    path = '/4'

    @route(
        path='/5556',  # Optional
        request_data=RequestData,
        response_data=ResponseData,
        func=func2,
    )
    def ping(self):
        pass


class API(NexiumAPI):
    path = '/1' # Optional

    router2 = Router2()

    @route(
        path='/2', # Optional
        request_data=RequestData,
        response_data=ResponseData,
        func=func,
    )
    def ping(self):
        pass


app = API().get_fastapi(
    title='Test Project',
    contact={
        'name': 'Nexium',
        'url': 'https://nexium.me',
        'email': 'info@nexium.me',
    },
    license_info={
        'name': 'Apache 2.0',
        'url': 'https://www.apache.org/licenses/LICENSE-2.0.html',
    },
)
